﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
' *** Licencia
' *** Este código sirve para interactuar con el servidor de licencias y validar las mismas
' *** Julio 2014
' *** JLP

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim directorioLicencia As String = "/LicTMG/"
	Dim ficheroLicencia As String = "tokenPlateRdr.lic"

	Dim urlInitLicense As String = "http://licenses.the-mobility-group.com/webservices/initlic.php"	
	Dim urlValidaLicense As String = "http://licenses.the-mobility-group.com/webservices/validalic.php"	
End Sub


Sub MostrarDialogo As String
	Dim d As InputDialog	
	Dim valor As Int
		
	d.InputType = d.INPUT_TYPE_TEXT	
	valor=d.Show("Type your company token or TOKEN00000000001 for a two weeks license", "TMG Apps License request","Accept","","Cancel",Null)
	
	If valor=DialogResponse.POSITIVE Then 
		Return d.Input
	Else
		Return ""
	End If
End Sub

Sub ValidaFicheroLicencia As Boolean
	' Comprobamos si la App tiene licencia instalada
	If File.Exists(File.DirRootExternal & directorioLicencia,ficheroLicencia) = False Then 
		Return False
	Else
		Return True
	End If
End Sub

Sub GuardarLicencia(tokenLicense As String)
	' Creamos el directorio de licencia de la aplicación si no está creado
	If File.Exists(directorioLicencia,"") = False Then 
		File.MakeDir(File.DirRootExternal,directorioLicencia)
	End If
	' Abrimos el fichero y lo guardamos
    Dim TextWriter1 As TextWriter	
    TextWriter1.Initialize(File.OpenOutput(File.DirRootExternal & directorioLicencia,ficheroLicencia,False))
    TextWriter1.WriteLine(tokenLicense)
    TextWriter1.Close  
End Sub

Sub LeerLicencia As String
	Dim textReader1 As TextReader
	Dim valor As String

	textReader1.Initialize(File.OpenInput(File.DirRootExternal & directorioLicencia,ficheroLicencia))
	valor=textReader1.ReadLine
	textReader1.Close
	
	Return valor
End Sub 

Sub BorradoFicheroLicencia 
	File.Delete(File.DirRootExternal & directorioLicencia,ficheroLicencia)
End Sub


Sub ValidaLicenciaActiva(pIdProducto As Int) As Boolean
	Dim tokenLicense As String
	
	If Sincronizacion.ExisteConexion Then 
		tokenLicense = LeerLicencia
		' Invocamos el webservice
		Try
				Main.jobValidaLicense.Download2(urlValidaLicense,Array As String("tokenLicense",tokenLicense,"valorIMEI",Credenciales.getIMEI,"idProducto",pIdProducto,"format","json"))
				Return True
				' Fin proceso de descarga inicial: El jobdone lanzara el resto de cosas.
			Catch
				Log(LastException.Message)
				Msgbox("Error communicating with LicenseServer" ,"TMG Plate Reader - Messages")
				Return False
		End Try		
	Else
				Msgbox("Error: You need a data connection " ,"TMG Plate Reader - Messages")
				Return False
	End If
End Sub

Sub DescargaLicencia(pTokenEmpresa As String,pIdProducto As Int) As Boolean
	If Sincronizacion.ExisteConexion Then 
		Try
				Main.jobInitLicense.Download2(urlInitLicense,Array As String("tokenEmpresa",pTokenEmpresa,"valorIMEI",Credenciales.getIMEI,"idProducto",pIdProducto,"format","json"))
				Return True
				' Fin proceso de descarga inicial: El jobdone lanzara el resto de cosas.
			Catch
				Log(LastException.Message)
				Msgbox("Error communicating with LicenseServer" ,"TMG Plate Reader - Messages")
				Return False
		End Try		
	Else
				Msgbox("Error: You need a data connection " ,"TMG Plate Reader - Messages")
				Return False
	End If
End Sub



Sub ParsearDatosLicencia(resultados As String) As Boolean
' Procedimiento para parsear la licencia recuperada al inicializar 

    Dim parser As JSONParser
	Dim nivelTop As Map
	Dim registros As List
	Dim r As Map
	Dim activo As Int
	Dim tokenLicense As String
		
	nivelTop.Initialize
	parser.Initialize(resultados)  ' salida contiene el texto a parsear
	nivelTop = parser.NextObject
	registros = nivelTop.Get("consulta")
	
	' Solo tenemos un registro en la salida		
	r = registros.Get(0)
	
	
	tokenLicense = r.GetValueAt(0)
	activo = r.GetValueAt(1)
	
	If activo=1 Then 
		GuardarLicencia(tokenLicense)
		Return True
	Else If activo=-1 Then 
		Msgbox2("Invalid Company Token. Please contact comercial@the-mobility-group.com","TMG Apps License Server","Accept","","",Null)		
		Return False
	Else If activo=-2 Then 
		Msgbox2("Demo license expired. Please contact comercial@the-mobility-group.com","TMG Apps License Server","Accept","","",Null)		
		Return False			
	Else
		Msgbox2("Disabled License. Please contact comercial@the-mobility-group.com","TMG Apps License Server","Accept","","",Null)		
		Return False
	End If 	
End Sub

Sub ParsearLicencia(resultados As String) As Boolean
' Procedimiento para parsear la licencia recuperada
' Recuperamos activo, fechaIni, fechafin

    Dim parser As JSONParser
	Dim nivelTop As Map
	Dim registros As List
	Dim r As Map
	Dim activo As Int
	Dim fechaIni As String
	Dim fechafin As String
	Dim now As Long = DateTime.now
	Dim dt As String
		
	nivelTop.Initialize
	parser.Initialize(resultados)  ' salida contiene el texto a parsear
	nivelTop = parser.NextObject
	registros = nivelTop.Get("consulta")

	
	' Solo tenemos un registro en la salida		
	r = registros.Get(0)
	' Obtenemos los valores del registro
	
	If resultados.Contains("registro") Then 
		Dim auxMap As Map
		auxMap.Initialize
		auxMap = r.Get("registro")					
		' Recuperamos los datos de la licencia
		activo= auxMap.Get("activo")
		fechaIni=auxMap.Get("FechaIni")			
		fechafin=auxMap.Get("FechaFin")
	Else
		activo = r.GetValueAt(2)
		fechaIni = r.GetValueAt(1)
		fechafin = r.GetValueAt(0)
	End If
		
	' Calculo de la fecha del día de hoy	
	DateTime.DateFormat = "yyyy-MM-dd" ' 
	dt = DateTime.Date(now)
	
	If activo=1 Then 
		' Validamos que todavía esté vigente
		If DateTime.DateParse(dt)>DateTime.DateParse(fechafin) Then  
			Msgbox2("Expired License. Please contact support","TMG Apps License Server","Accept","","",Null)		
			' Borramos el fichero de licencia que esté habilitado
			BorradoFicheroLicencia
			Return False
		  Else If DateTime.DateParse(dt)<DateTime.DateParse(fechaIni) Then 
			Msgbox2("Invalid system date. Please contact support","TMG Apps License Server","Accept","","",Null)		
			' Borramos el fichero de licencia que esté habilitado
			BorradoFicheroLicencia
			Return False
		  Else If DateTime.DateParse(dt)>=DateTime.DateParse(fechaIni) AND DateTime.DateParse(dt)<=DateTime.DateParse(fechafin) Then 
			' Licencia válida
			Return True
		End If
		Return True
	Else If activo=2 Then 
		Msgbox2("Invalid License. Please contact support","TMG Apps License Server","Accept","","",Null)		
		' Borramos el fichero de licencia que esté habilitado
		BorradoFicheroLicencia
		Return False
	Else
		Msgbox2("Disabled License. Please contact support","TMG Apps License Server","Accept","","",Null)		
		' Borramos el fichero de licencia que esté habilitado
		BorradoFicheroLicencia
		Return False
	End If 	
End Sub