﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub DescargaPrimeraTabla As Boolean
	
	Main.tablaComunicaciones = "tablas_sincronizacion"
	Try
			Login.job2.Download2(Main.url,Array As String("tabla",Main.tablaComunicaciones, "format","json"))
			Return True
			' Fin proceso de descarga inicial: El jobdone lanzara el resto de cosas.
		Catch
			Log(LastException.Message)
			Msgbox("Error communicationg with:" & Main.url,"TMG Plate Reader - Messages")
			Return False
	End Try		
End Sub



Sub ExisteConexion As Boolean
	Dim server As ServerSocket 'Add a reference to the network library
	Dim r As Boolean
	
    server.Initialize(0, "")
    If server.GetMyIP = "127.0.0.1" Then  'this is the local host address
        r = False
	Else 
		r = True	
    End If
	
	Return r	
End Sub

' Parseo datos provinientes del JSON 
' Prepara cada registro para insertar 

Sub Parsea_Registros(tabla As String, pAux As Map, dt As String) As Map
Dim pM As Map

Try
	pM.Initialize	
	Select tabla
		Case "tablas_sincronizacion"
			pM.Put("id",pAux.Get("id"))
			pM.Put("Nombre_Tabla",pAux.Get("Nombre_Tabla"))
			pM.Put("tipo_tabla",pAux.Get("tipo_tabla"))
			pM.Put("orden",pAux.Get("orden"))
			pM.Put("ULT_TIMESTAMP",dt)						
			
		Case "Configuracion"
			pM.Put("id",pAux.Get("id"))
			pM.Put("Name",pAux.Get("Name"))
			pM.Put("Value",pAux.Get("Value"))			
			pM.Put("ULT_TIMESTAMP",dt)							
			
		Case "Tipo_Usuario"
			pM.Put("id",pAux.Get("id"))
			pM.Put("Descripcion",pAux.Get("Descripcion"))
			pM.Put("ULT_TIMESTAMP",dt)
			
		Case "Country_Code"
			pM.Put("id",pAux.Get("id"))
			pM.Put("Descripcion",pAux.Get("descripcion"))
			pM.Put("ULT_TIMESTAMP",dt)
			
		Case "Usuario"
			pM.Put("id",pAux.Get("id"))
			pM.Put("Nombre",pAux.Get("Nombre"))
			pM.Put("Apellidos",pAux.Get("Apellidos"))
			pM.Put("Tipo_Usuario_id",pAux.Get("Tipo_Usuario_id"))
			pM.Put("Email",pAux.Get("Email"))
			pM.Put("Ultimo_Login",pAux.Get("Ultimo_Login"))
			pM.Put("login",pAux.Get("login"))
			pM.Put("password",pAux.Get("password"))
			pM.Put("ULT_TIMESTAMP",dt)
			
		Case "Estados"
			pM.Put("id",pAux.Get("id"))
			pM.Put("Descripcion",pAux.Get("Descripcion"))				
			pM.Put("ULT_TIMESTAMP",dt)	
					
		Case "FICHEROS"
			pM.Put("id",pAux.Get("id"))				
			pM.Put("Usuario_id",pAux.Get("Usuario_id"))				
			pM.Put("Origen",pAux.Get("Origen"))				
			pM.Put("Nombre_Completo",pAux.Get("Nombre_Completo"))				
			pM.Put("Tipo",pAux.Get("Tipo"))				
			pM.Put("ULT_TIMESTAMP",dt)
			
		Case "Marca_vehiculo"
			pM.Put("id",pAux.Get("id"))				
			pM.Put("nombre",pAux.Get("nombre"))				
			pM.Put("slug",pAux.Get("slug"))				
			pM.Put("ULT_TIMESTAMP",dt)
		
		Case "Modelo_vehiculo"
			pM.Put("id_marca",pAux.Get("id_marca"))	
			pM.Put("id",pAux.Get("id"))				
			pM.Put("nombre",pAux.Get("nombre"))				
			pM.Put("slug",pAux.Get("slug"))				
			pM.Put("ULT_TIMESTAMP",dt)
			
		Case "US_State"
			pM.Put("id",pAux.Get("id"))				
			pM.Put("Name",pAux.Get("Name"))				
			pM.Put("Short-name",pAux.Get("Short-name"))				
			pM.Put("ULT_TIMESTAMP",dt)
			
		Case "Violation_Type"
			pM.Put("id",pAux.Get("id"))				
			pM.Put("name",pAux.Get("name"))				
			pM.Put("ULT_TIMESTAMP",dt)
		
		Case "Violation_List"
			pM.Put("pcode",pAux.Get("pcode"))				
			pM.Put("violationtype_id",pAux.Get("violationtype_id"))										
			pM.Put("shortdesc",pAux.Get("shortdesc"))				
			pM.Put("description",pAux.Get("description"))							
			pM.Put("fine",pAux.Get("fine"))										
			pM.Put("required_pics",pAux.Get("required_pics"))													
			pM.Put("active",pAux.Get("active"))																
			pM.Put("ULT_TIMESTAMP",dt)
				
	End Select						
Catch
	Log(LastException.Message)
End Try

Return pM
	
End Sub

Sub ParsearDatosTablas(resultados As String) 
' Procedimiento para sincronizar todas las tablas

    Dim parser As JSONParser
	Dim nivelTop As Map
	Dim registros As List
	Dim r As Map
	Dim id_tabla As Int
	
	parser.Initialize(resultados)  ' salida contiene el texto a parsear
	' El top es un object
	' después tiene un array de objects
	nivelTop = parser.NextObject
	registros = nivelTop.Get("consulta")
	'Dim id, Nombre, Provincia_id As String
	Dim ListOfMaps As List
	ListOfMaps.Initialize
	
	Dim now As Long = DateTime.now
	Dim dt As String
	DateTime.DateFormat = "yyyy-MM-dd HH:mm:ss" ' 
	dt = DateTime.Date(now)
	
	For i = 0 To registros.Size -1 
	' tratamiento registros
		r = registros.Get(i)
	' Obtenemos los valores del registro
		Dim auxMap As Map
		Dim m As Map
		m.Initialize
		auxMap = r.Get("registro")
		m=Parsea_Registros(Main.tablaComunicaciones, auxMap, dt)																
		ListOfMaps.Add(m) 'Añadimos los campos parseados de la tabla
	Next
	' Primero borramos la tabla: Cuando tengamos el incremental no hace falta.
	' Insertamos los registros solo si tienen algún valor
	Try
		If registros.Size>0 Then 
			If (Main.tablaComunicaciones<>"Configuracion") OR Not(Parameters.ConfiguracionInicializada) Then 
				Main.bdbsql.ExecNonQuery("DELETE FROM " & Main.tablaComunicaciones)
				DBUtils.InsertMaps(Main.bdbsql, Main.tablaComunicaciones, ListOfMaps)			
				id_tabla = BuscarIndice(Main.tablaComunicaciones)
				Main.bdbsql.ExecNonQuery2("INSERT INTO Log_Sincronizacion VALUES (?,?,?,?,?)",Array As Object(id_tabla,Login.idUsuarioConectado,dt,0,registros.Size))
			End If
		End If    
	Catch
		Log("Error descarga tablas: " & LastException.Message)
	End Try	
End Sub

Sub BuscarIndice(pNombre As String) As Int
Dim c As Cursor
Dim query As String="SELECT id FROM tablas_sincronizacion WHERE Nombre_Tabla='"&pNombre &"'"
Dim valor As Int

	c = Main.bdbsql.ExecQuery(query)
	If c.RowCount > 0 Then 
 		c.Position = 0	
		valor=c.GetInt("id")
		c.Close
		Return valor
	Else
		c.Close
		Return -1
	End If
End Sub
